# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pipe character`|` (e.g. `|ABC123`). Please note that this is only the case when the External Id is within the route. If the External Id is contained within the body of the request, do not append the pipe character.    ## Rate Limiting  Requests are rate limited at a default rate of 100 requests per minute    ## Transaction Id  Each request can be supplied with a `TransactionId` GUID which will be logged with the request. The `Transaction Id` can be supplied as an HTTP Header: `TransactionId=[transactionId]`. If no `Transaction Id` is supplied, one will be generated for you. Please use a distinct TransactionId for each request.

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional, Union
from pydantic import BaseModel, StrictFloat, StrictInt
from pydantic import Field
from redrover_api.models.absence_reason_tracking_type_enum import AbsenceReasonTrackingTypeEnum
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class AbsenceReasonBalanceResponse(BaseModel):
    """
    AbsenceReasonBalanceResponse
    """ # noqa: E501
    id: Optional[StrictInt] = Field(default=None, description="The Red Rover internal Id of AbsenceReasonBalance (numeric)")
    employee_id: Optional[StrictInt] = Field(default=None, description="The Red Rover internal Id of Employee (numeric)", alias="employeeId")
    school_year_id: Optional[StrictInt] = Field(default=None, description="The Red Rover internal Id of SchoolYear (numeric)", alias="schoolYearId")
    absence_reason_id: Optional[StrictInt] = Field(default=None, description="The Red Rover internal Id of AbsenceReason (numeric)", alias="absenceReasonId")
    absence_reason_category_id: Optional[StrictInt] = Field(default=None, description="The Red Rover internal Id of AbsenceReasonCategory (numeric)", alias="absenceReasonCategoryId")
    balance_as_of: Optional[datetime] = Field(default=None, description="The 'As of' date as to when this balance was last update", alias="balanceAsOf")
    initial_balance: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="How much the employee initially had", alias="initialBalance")
    used_balance: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="How much has been used", alias="usedBalance")
    unused_balance: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="How much has not been used", alias="unusedBalance")
    earned_balance: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The amount of balance that was earned", alias="earnedBalance")
    net_balance: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The net balance", alias="netBalance")
    used_balance_calculated_at_utc: Optional[datetime] = Field(default=None, description="When the last time that the 'used' balance was calculated", alias="usedBalanceCalculatedAtUtc")
    absence_reason_tracking_type: Optional[AbsenceReasonTrackingTypeEnum] = Field(default=None, alias="absenceReasonTrackingType")
    __properties: ClassVar[List[str]] = ["id", "employeeId", "schoolYearId", "absenceReasonId", "absenceReasonCategoryId", "balanceAsOf", "initialBalance", "usedBalance", "unusedBalance", "earnedBalance", "netBalance", "usedBalanceCalculatedAtUtc", "absenceReasonTrackingType"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of AbsenceReasonBalanceResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # set to None if absence_reason_id (nullable) is None
        # and model_fields_set contains the field
        if self.absence_reason_id is None and "absence_reason_id" in self.model_fields_set:
            _dict['absenceReasonId'] = None

        # set to None if absence_reason_category_id (nullable) is None
        # and model_fields_set contains the field
        if self.absence_reason_category_id is None and "absence_reason_category_id" in self.model_fields_set:
            _dict['absenceReasonCategoryId'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of AbsenceReasonBalanceResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "employeeId": obj.get("employeeId"),
            "schoolYearId": obj.get("schoolYearId"),
            "absenceReasonId": obj.get("absenceReasonId"),
            "absenceReasonCategoryId": obj.get("absenceReasonCategoryId"),
            "balanceAsOf": obj.get("balanceAsOf"),
            "initialBalance": obj.get("initialBalance"),
            "usedBalance": obj.get("usedBalance"),
            "unusedBalance": obj.get("unusedBalance"),
            "earnedBalance": obj.get("earnedBalance"),
            "netBalance": obj.get("netBalance"),
            "usedBalanceCalculatedAtUtc": obj.get("usedBalanceCalculatedAtUtc"),
            "absenceReasonTrackingType": obj.get("absenceReasonTrackingType")
        })
        return _obj


