# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pipe character`|` (e.g. `|ABC123`). Please note that this is only the case when the External Id is within the route. If the External Id is contained within the body of the request, do not append the pipe character.    ## Rate Limiting  Requests are rate limited at a default rate of 100 requests per minute    ## Transaction Id  Each request can be supplied with a `TransactionId` GUID which will be logged with the request. The `Transaction Id` can be supplied as an HTTP Header: `TransactionId=[transactionId]`. If no `Transaction Id` is supplied, one will be generated for you. Please use a distinct TransactionId for each request.

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictBool
from pydantic import Field
from redrover_api.models.int32_locator_request import Int32LocatorRequest
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class AccessControlRequest(BaseModel):
    """
    AccessControlRequest
    """ # noqa: E501
    all_locations: Optional[StrictBool] = Field(default=None, description="If the Administrator can be granted access to all Locations", alias="allLocations")
    all_position_types: Optional[StrictBool] = Field(default=None, description="If the Administrator can be granted access to all Position Types", alias="allPositionTypes")
    locations: Optional[List[Int32LocatorRequest]] = Field(default=None, description="The Locations that the Administrator is granted access to")
    location_groups: Optional[List[Int32LocatorRequest]] = Field(default=None, description="The Location Groups that the Administrator is granted access to", alias="locationGroups")
    position_types: Optional[List[Int32LocatorRequest]] = Field(default=None, description="The Position Types that the Administrator is granted access to", alias="positionTypes")
    __properties: ClassVar[List[str]] = ["allLocations", "allPositionTypes", "locations", "locationGroups", "positionTypes"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of AccessControlRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in locations (list)
        _items = []
        if self.locations:
            for _item in self.locations:
                if _item:
                    _items.append(_item.to_dict())
            _dict['locations'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in location_groups (list)
        _items = []
        if self.location_groups:
            for _item in self.location_groups:
                if _item:
                    _items.append(_item.to_dict())
            _dict['locationGroups'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in position_types (list)
        _items = []
        if self.position_types:
            for _item in self.position_types:
                if _item:
                    _items.append(_item.to_dict())
            _dict['positionTypes'] = _items
        # set to None if all_locations (nullable) is None
        # and model_fields_set contains the field
        if self.all_locations is None and "all_locations" in self.model_fields_set:
            _dict['allLocations'] = None

        # set to None if all_position_types (nullable) is None
        # and model_fields_set contains the field
        if self.all_position_types is None and "all_position_types" in self.model_fields_set:
            _dict['allPositionTypes'] = None

        # set to None if locations (nullable) is None
        # and model_fields_set contains the field
        if self.locations is None and "locations" in self.model_fields_set:
            _dict['locations'] = None

        # set to None if location_groups (nullable) is None
        # and model_fields_set contains the field
        if self.location_groups is None and "location_groups" in self.model_fields_set:
            _dict['locationGroups'] = None

        # set to None if position_types (nullable) is None
        # and model_fields_set contains the field
        if self.position_types is None and "position_types" in self.model_fields_set:
            _dict['positionTypes'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of AccessControlRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "allLocations": obj.get("allLocations"),
            "allPositionTypes": obj.get("allPositionTypes"),
            "locations": [Int32LocatorRequest.from_dict(_item) for _item in obj.get("locations")] if obj.get("locations") is not None else None,
            "locationGroups": [Int32LocatorRequest.from_dict(_item) for _item in obj.get("locationGroups")] if obj.get("locationGroups") is not None else None,
            "positionTypes": [Int32LocatorRequest.from_dict(_item) for _item in obj.get("positionTypes")] if obj.get("positionTypes") is not None else None
        })
        return _obj


