# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pipe character`|` (e.g. `|ABC123`). Please note that this is only the case when the External Id is within the route. If the External Id is contained within the body of the request, do not append the pipe character.    ## Rate Limiting  Requests are rate limited at a default rate of 100 requests per minute    ## Transaction Id  Each request can be supplied with a `TransactionId` GUID which will be logged with the request. The `Transaction Id` can be supplied as an HTTP Header: `TransactionId=[transactionId]`. If no `Transaction Id` is supplied, one will be generated for you. Please use a distinct TransactionId for each request.

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel, StrictBool, StrictStr
from pydantic import Field
from redrover_api.models.int32_locator_request import Int32LocatorRequest
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class PositionScheduleCustomVariantRequest(BaseModel):
    """
    PositionScheduleCustomVariantRequest
    """ # noqa: E501
    start_time: Optional[StrictStr] = Field(default=None, description="The start time", alias="startTime")
    half_day_morning_end_time: Optional[StrictStr] = Field(default=None, description="Halfday morning start time", alias="halfDayMorningEndTime")
    half_day_afternoon_start_time: Optional[StrictStr] = Field(default=None, description="Halfday afternoon start time", alias="halfDayAfternoonStartTime")
    end_time: Optional[StrictStr] = Field(default=None, description="The next end time", alias="endTime")
    next_start_time: Optional[StrictStr] = Field(default=None, description="The next start time", alias="nextStartTime")
    is_work_time: Optional[StrictBool] = Field(default=None, description="If is work time", alias="isWorkTime")
    needs_replacement: Optional[StrictBool] = Field(default=None, description="If needs replacement", alias="needsReplacement")
    needs_replacement_am: Optional[StrictBool] = Field(default=None, description="If needs replacement for AM", alias="needsReplacementAm")
    needs_replacement_pm: Optional[StrictBool] = Field(default=None, description="If needs replacement for PM", alias="needsReplacementPm")
    work_day_schedule_variant_type: Optional[Int32LocatorRequest] = Field(default=None, alias="workDayScheduleVariantType")
    __properties: ClassVar[List[str]] = ["startTime", "halfDayMorningEndTime", "halfDayAfternoonStartTime", "endTime", "nextStartTime", "isWorkTime", "needsReplacement", "needsReplacementAm", "needsReplacementPm", "workDayScheduleVariantType"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of PositionScheduleCustomVariantRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of work_day_schedule_variant_type
        if self.work_day_schedule_variant_type:
            _dict['workDayScheduleVariantType'] = self.work_day_schedule_variant_type.to_dict()
        # set to None if start_time (nullable) is None
        # and model_fields_set contains the field
        if self.start_time is None and "start_time" in self.model_fields_set:
            _dict['startTime'] = None

        # set to None if half_day_morning_end_time (nullable) is None
        # and model_fields_set contains the field
        if self.half_day_morning_end_time is None and "half_day_morning_end_time" in self.model_fields_set:
            _dict['halfDayMorningEndTime'] = None

        # set to None if half_day_afternoon_start_time (nullable) is None
        # and model_fields_set contains the field
        if self.half_day_afternoon_start_time is None and "half_day_afternoon_start_time" in self.model_fields_set:
            _dict['halfDayAfternoonStartTime'] = None

        # set to None if end_time (nullable) is None
        # and model_fields_set contains the field
        if self.end_time is None and "end_time" in self.model_fields_set:
            _dict['endTime'] = None

        # set to None if next_start_time (nullable) is None
        # and model_fields_set contains the field
        if self.next_start_time is None and "next_start_time" in self.model_fields_set:
            _dict['nextStartTime'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of PositionScheduleCustomVariantRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "startTime": obj.get("startTime"),
            "halfDayMorningEndTime": obj.get("halfDayMorningEndTime"),
            "halfDayAfternoonStartTime": obj.get("halfDayAfternoonStartTime"),
            "endTime": obj.get("endTime"),
            "nextStartTime": obj.get("nextStartTime"),
            "isWorkTime": obj.get("isWorkTime"),
            "needsReplacement": obj.get("needsReplacement"),
            "needsReplacementAm": obj.get("needsReplacementAm"),
            "needsReplacementPm": obj.get("needsReplacementPm"),
            "workDayScheduleVariantType": Int32LocatorRequest.from_dict(obj.get("workDayScheduleVariantType")) if obj.get("workDayScheduleVariantType") is not None else None
        })
        return _obj


