# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pipe character`|` (e.g. `|ABC123`). Please note that this is only the case when the External Id is within the route. If the External Id is contained within the body of the request, do not append the pipe character.    ## Rate Limiting  Requests are rate limited at a default rate of 100 requests per minute    ## Transaction Id  Each request can be supplied with a `TransactionId` GUID which will be logged with the request. The `Transaction Id` can be supplied as an HTTP Header: `TransactionId=[transactionId]`. If no `Transaction Id` is supplied, one will be generated for you. Please use a distinct TransactionId for each request.

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Any, ClassVar, Dict, List, Optional
from pydantic import BaseModel
from pydantic import Field
from redrover_api.models.int32_locator_request import Int32LocatorRequest
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class SubstitutePreferencesRequest(BaseModel):
    """
    SubstitutePreferencesRequest
    """ # noqa: E501
    favorite_substitutes: Optional[List[Int32LocatorRequest]] = Field(default=None, description="Substitutes that are preferred favorites", alias="favoriteSubstitutes")
    blocked_substitutes: Optional[List[Int32LocatorRequest]] = Field(default=None, description="Substitutes that are blocked", alias="blockedSubstitutes")
    auto_assigned_substitutes: Optional[List[Int32LocatorRequest]] = Field(default=None, description="Substitutes that can be auto assigned", alias="autoAssignedSubstitutes")
    __properties: ClassVar[List[str]] = ["favoriteSubstitutes", "blockedSubstitutes", "autoAssignedSubstitutes"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of SubstitutePreferencesRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in favorite_substitutes (list)
        _items = []
        if self.favorite_substitutes:
            for _item in self.favorite_substitutes:
                if _item:
                    _items.append(_item.to_dict())
            _dict['favoriteSubstitutes'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in blocked_substitutes (list)
        _items = []
        if self.blocked_substitutes:
            for _item in self.blocked_substitutes:
                if _item:
                    _items.append(_item.to_dict())
            _dict['blockedSubstitutes'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in auto_assigned_substitutes (list)
        _items = []
        if self.auto_assigned_substitutes:
            for _item in self.auto_assigned_substitutes:
                if _item:
                    _items.append(_item.to_dict())
            _dict['autoAssignedSubstitutes'] = _items
        # set to None if favorite_substitutes (nullable) is None
        # and model_fields_set contains the field
        if self.favorite_substitutes is None and "favorite_substitutes" in self.model_fields_set:
            _dict['favoriteSubstitutes'] = None

        # set to None if blocked_substitutes (nullable) is None
        # and model_fields_set contains the field
        if self.blocked_substitutes is None and "blocked_substitutes" in self.model_fields_set:
            _dict['blockedSubstitutes'] = None

        # set to None if auto_assigned_substitutes (nullable) is None
        # and model_fields_set contains the field
        if self.auto_assigned_substitutes is None and "auto_assigned_substitutes" in self.model_fields_set:
            _dict['autoAssignedSubstitutes'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of SubstitutePreferencesRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "favoriteSubstitutes": [Int32LocatorRequest.from_dict(_item) for _item in obj.get("favoriteSubstitutes")] if obj.get("favoriteSubstitutes") is not None else None,
            "blockedSubstitutes": [Int32LocatorRequest.from_dict(_item) for _item in obj.get("blockedSubstitutes")] if obj.get("blockedSubstitutes") is not None else None,
            "autoAssignedSubstitutes": [Int32LocatorRequest.from_dict(_item) for _item in obj.get("autoAssignedSubstitutes")] if obj.get("autoAssignedSubstitutes") is not None else None
        })
        return _obj


