# coding: utf-8

"""
    Red Rover API

    Access Red Rover data via this REST API for Organizations that have granted you access.    # Authentication  The API is protected by HTTP Basic Authentication.   Each application that connects to the API has a unique username and password that it must supply with every request.    This value needs to be supplied as an HTTP Header: `Authorization=BASIC [hash]`. The value of [hash] is the string username:password base64 encoded.    Endpoints marked for Basic Auth can be used with the Basic Auth username and password that you have been assigned.    # API Information  ## Api Key  Each Red Rover organization that has authorized your application has a unique API Key for your application.  To retrieve the API Key, you can use the Organization endpoint (`api/v1/organization`) which returns an ApiKey uniquely used for each Organization.    You must supply this as an HTTP Header when accessing that organization: `apiKey=[apiKey]`. The domains that require this `ApiKey` header are labeled as 'Requires an ApiKey'.    ## Identifier  Where an `Identifier` can be specified in the route, you may either supply the Red Rover Id of the object (numeric) or the External Id (alpha-numeric). When specifying an External Id, you will need to prepend the External Id with the pipe character`|` (e.g. `|ABC123`). Please note that this is only the case when the External Id is within the route. If the External Id is contained within the body of the request, do not append the pipe character.    ## Rate Limiting  Requests are rate limited at a default rate of 100 requests per minute    ## Transaction Id  Each request can be supplied with a `TransactionId` GUID which will be logged with the request. The `Transaction Id` can be supplied as an HTTP Header: `TransactionId=[transactionId]`. If no `Transaction Id` is supplied, one will be generated for you. Please use a distinct TransactionId for each request.

    The version of the OpenAPI document: v1
    Contact: dev@redroverk12.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from typing import Any, ClassVar, Dict, List, Optional, Union
from pydantic import BaseModel, StrictFloat, StrictInt
from pydantic import Field
from redrover_api.models.absence_reason_tracking_type_enum import AbsenceReasonTrackingTypeEnum
from redrover_api.models.int32_locator_request import Int32LocatorRequest
try:
    from typing import Self
except ImportError:
    from typing_extensions import Self

class TimeOffBalanceRequest(BaseModel):
    """
    TimeOffBalanceRequest
    """ # noqa: E501
    absence_reason: Optional[Int32LocatorRequest] = Field(default=None, alias="absenceReason")
    absence_reason_category: Optional[Int32LocatorRequest] = Field(default=None, alias="absenceReasonCategory")
    school_year: Optional[Int32LocatorRequest] = Field(default=None, alias="schoolYear")
    as_of: Optional[datetime] = Field(default=None, description="The 'AsOf' date", alias="asOf")
    absence_reason_tracking_type_id: Optional[AbsenceReasonTrackingTypeEnum] = Field(default=None, alias="absenceReasonTrackingTypeId")
    balance: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The balance for this time off balance request")
    __properties: ClassVar[List[str]] = ["absenceReason", "absenceReasonCategory", "schoolYear", "asOf", "absenceReasonTrackingTypeId", "balance"]

    model_config = {
        "populate_by_name": True,
        "validate_assignment": True,
        "protected_namespaces": (),
    }


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Create an instance of TimeOffBalanceRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        _dict = self.model_dump(
            by_alias=True,
            exclude={
            },
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of absence_reason
        if self.absence_reason:
            _dict['absenceReason'] = self.absence_reason.to_dict()
        # override the default output from pydantic by calling `to_dict()` of absence_reason_category
        if self.absence_reason_category:
            _dict['absenceReasonCategory'] = self.absence_reason_category.to_dict()
        # override the default output from pydantic by calling `to_dict()` of school_year
        if self.school_year:
            _dict['schoolYear'] = self.school_year.to_dict()
        # set to None if as_of (nullable) is None
        # and model_fields_set contains the field
        if self.as_of is None and "as_of" in self.model_fields_set:
            _dict['asOf'] = None

        # set to None if balance (nullable) is None
        # and model_fields_set contains the field
        if self.balance is None and "balance" in self.model_fields_set:
            _dict['balance'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Dict) -> Self:
        """Create an instance of TimeOffBalanceRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "absenceReason": Int32LocatorRequest.from_dict(obj.get("absenceReason")) if obj.get("absenceReason") is not None else None,
            "absenceReasonCategory": Int32LocatorRequest.from_dict(obj.get("absenceReasonCategory")) if obj.get("absenceReasonCategory") is not None else None,
            "schoolYear": Int32LocatorRequest.from_dict(obj.get("schoolYear")) if obj.get("schoolYear") is not None else None,
            "asOf": obj.get("asOf"),
            "absenceReasonTrackingTypeId": obj.get("absenceReasonTrackingTypeId"),
            "balance": obj.get("balance")
        })
        return _obj


